//! `SeaORM` Entity, @generated by sea-orm-codegen 1.1.0

use sea_orm::entity::prelude::*;

#[derive(Clone, Debug, PartialEq, DeriveEntityModel, Eq)]
#[sea_orm(table_name = "Passkey")]
pub struct Model {
    #[sea_orm(primary_key, auto_increment = false)]
    pub id: Uuid,
    #[sea_orm(column_name = "createdAt")]
    pub created_at: DateTime,
    #[sea_orm(column_name = "ownerName", column_type = "Text")]
    pub owner_name: String,
    #[sea_orm(
        column_name = "credentialId",
        column_type = "VarBinary(StringLen::None)",
        unique
    )]
    pub credential_id: Vec<u8>,
    #[sea_orm(column_name = "publicKey", column_type = "VarBinary(StringLen::None)")]
    pub public_key: Vec<u8>,
    #[sea_orm(column_name = "displayName", column_type = "Text")]
    pub display_name: String,
    #[sea_orm(column_name = "rpId", column_type = "Text")]
    pub rp_id: String,
    #[sea_orm(column_name = "signCount")]
    pub sign_count: i64,
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveRelation)]
pub enum Relation {
    #[sea_orm(
        belongs_to = "super::user::Entity",
        from = "Column::OwnerName",
        to = "super::user::Column::Username",
        on_update = "Cascade",
        on_delete = "Restrict"
    )]
    User,
}

impl Related<super::user::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::User.def()
    }
}

impl ActiveModelBehavior for ActiveModel {}
